/**********************************************************************
	PIC32MX :: HEXt@C̃AhXu.
 **********************************************************************
 */
#include "easy.h"
#include <malloc.h>
#include <string.h>

#define	CHECKSUM_CALC	(1)

typedef	unsigned char uchar;

Usage(
	" ===== intel HEX to Dump =====\n"
	"\n"
	"Usage:\n"
	"$ hex2pickit3 infile.hex outfile.hex\n"
);

static	char	infile[256];
static	char	outfile[256];

static	unsigned char 	databuf[256];
static	int				dataidx;

static	int				adr_u = 0;		// hexrec mode 4
/**********************************************************************
 *		
 **********************************************************************
 */
int read_hex1(char *s)
{
	char buf[16];
	int rc = -1;

	buf[0] = s[0];
	buf[1] = s[1];
	buf[2] = 0;
	sscanf(buf,"%x",&rc);
	return rc;
}

void print_line(int adrs,uchar *buf,int cnt)
{
	int i;
	printf("%04x:",adrs);
	for(i=0;i<cnt;i++) {
		printf(" %02x",buf[i]);
	}
	printf("\n");
}
void print_multiline(int adrs,uchar *buf,int cnt)
{
	int l;
	while(cnt) {
		l=cnt;
		if(l>=16) l=16;
		print_line(adrs,buf,l);
		cnt-=l;
		buf+=l;
		adrs+=l;
	}
}
/**********************************************************************
 *		
 **********************************************************************
 */
int read_hex(char *s)
{
	int rc;

	dataidx = 0;
	while(*s) {
		rc = read_hex1(s);s+=2;
		if(rc<0) return rc;
		databuf[dataidx++]=rc;
	}
	return 0;
}

/**********************************************************************
 *		
 **********************************************************************
 */
int	ihex(unsigned char *buf,int length)
{
	int adrs = (buf[1] << 8) | buf[2];
	int cnt  =  buf[0];
	int i;
	int sum=0;

#if	CHECKSUM_CALC
	for(i=0;i<length;i++) {
		sum += buf[i];
	}
//	printf("checksum=%x\n",sum);
	if( (sum & 0xff) != 0 ) {
		fprintf(stderr,"HEX RECORD Checksum Error! sum=%x\n", sum);
		exit(-1);
	}
#endif


	buf += 4;

	adrs |= adr_u;
	print_multiline(adrs,buf,cnt);

	return 0;
}
/**********************************************************************
 *		
 **********************************************************************
 */
int	write_ihex(int scmd,unsigned char *buf,int length)
{
	int adr_exec;
	switch(scmd) {
		case 0x00:	//f[^R[h:
					//f[^tB[h͏܂ׂf[^łB
			return ihex(buf,length);
		case 0x01:	//GhR[h:
					//HEXt@C̏I.t񖳂.
			return 0;
			break;
		case 0x02:	//ZOgAhXR[h:
					//f[^tB[hɂ̓ZOgAhXB Ƃ΁A
					//:02000002E0100C
					//		   ~~~~
					//
			break;
		case 0x03:	//X^[gZOgAhXR[h.
			break;
		case 0x04:	//gjAAhXR[h.
					//̃R[hł32rbgAhX̂16rbg
					//irbg32`rbg16́j^B
				adr_u = (buf[4]<<24)|(buf[5]<<16);
//				printf("adr_u=%x\n",adr_u);
				return 0;
			break;
		case 0x05:	//X^[gjAAhXF
					//Ⴆ
					//:04000005FF000123D4
					//         ~~~~~~~~
					//ƂȂĂ΁AFF000123hԒnX^[gAhXɂȂB
				adr_exec = (buf[4]<<24)|(buf[5]<<16)|(buf[6]<<8)|(buf[7]);
				printf(":scmd=5 start=%x\n",adr_exec);

			break;
		
	}
	printf("scmd=%x\n",scmd);
	return 0;
}
//	  0 1 2 3 4 5 6
//	:02000004BFC07B
//	    cmd~~
//		  adr~~~~
//			 csum~~
void write_cmd04(unsigned char *buf)
{
	buf[4] &= 0x1f;	// 0b0001_1111 ADDRESS[23:16]
	
	int i;
	int sum=0;

	for(i=0;i<6;i++) {
		sum += buf[i];
	}
//	printf("checksum=%x\n",sum);
	buf[6] = (-sum) & 0xff;

	fprintf(ofp,":");
	for(i=0;i<7;i++) {
		fprintf(ofp,"%02X",buf[i]);
	}
	fprintf(ofp,"\r\n");

}

/**********************************************************************
 *		
 **********************************************************************
 0 1 2 3 4
:1000100084C083C082C081C080C07FC07EC07DC0DC
 ~~ f[^
   ~~~~ AhX
       ~~ R[h^Cv
         ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~f[^ 
                                         ~~`FbNT.
 */
int	read_ihex(char *s)
{
	int c;
	read_hex(s);
	c = databuf[3];

	switch(c) {
	 case 0x04:	//gjAAhXR[h.
				//̃R[hł32rbgAhX̂16rbg
				//irbg32`rbg16́j^B
			//adr_u = (databuf[4]<<24)|(databuf[5]<<16);
			//printf("adr_u=%x\n",adr_u);
			write_cmd04(databuf);
			break;
	 default:
			fprintf(ofp,":%s\r\n",s);
			break;
	}
	return 0;
}
/**********************************************************************
 *		
 **********************************************************************
 */
int	read_line(char *s)
{
	int c;
	c = *s;
	if(c==0) return 0;
	if(c!=':') {
		printf("Input garbled. \"%s\"\n",s);
	}
	return read_ihex(s+1);
}

/**********************************************************************
 *		
 **********************************************************************
 */
int filter_cmd()
{
	char buf[1024];
	int rc,eof;
	Ropen(infile);
	Wopen(outfile);
	while(1) {
		eof = getln(buf,ifp);
		if(eof == EOF) break;
		rc  = read_line(buf);
	}
	Rclose();
	Wclose();
	
	(void)rc;
	return 0;
}
/**********************************************************************
 *		
 **********************************************************************
 */
int	main(int argc,char **argv)
{
	Getopt(argc,argv);
	if(argc<3) {
		usage();
	}
	strcpy(infile ,argv[1]);
	strcpy(outfile,argv[2]);
	filter_cmd();

	return 0;
}

/**********************************************************************
 *		
 **********************************************************************
 */
